Fix: bashate E003 warnings
[releng/global-jjb.git] / shell / release-job.sh
1 #!/bin/bash -l
2 # SPDX-License-Identifier: EPL-1.0
3 ##############################################################################
4 # Copyright (c) 2019 The Linux Foundation and others.
5 #
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Eclipse Public License v1.0
8 # which accompanies this distribution, and is available at
9 # http://www.eclipse.org/legal/epl-v10.html
10 ##############################################################################
11 echo "---> release-job.sh"
12 set -eu -o pipefail
13
14 # shellcheck disable=SC1090
15 source ~/lf-env.sh
16
17 # Version controlled by JJB_VERSION
18 lf-activate-venv lftools pip idna==2.9 lftools jsonschema twine yq readline
19
20 # show installed versions
21 python -m pip --version
22 python -m pip freeze
23
24 ##########################
25 # Set Variables Functions.
26 ##########################
27
28 set_variables_artifact(){
29     echo "INFO: Setting artifact variables"
30     if [[ -z ${VERSION:-} ]]; then
31         VERSION=$(yq -r ".version" "$release_file")
32     fi
33     if [[ -z ${GIT_TAG:-} ]]; then
34         if grep -q "git_tag" "$release_file" ; then
35             GIT_TAG=$(yq -r ".git_tag" "$release_file")
36         else
37             GIT_TAG="$VERSION"
38         fi
39     fi
40     if [[ -z ${REF:-} ]]; then
41         REF=$(yq -r ".ref" "$release_file")
42     fi
43
44     printf "\t%-30s\n" RELEASE_ARTIFACT_INFO:
45     printf "\t%-30s %s\n" GERRIT_REF_TO_TAG: "$REF"
46     printf "\t%-30s %s\n" VERSION: "$VERSION"
47     printf "\t%-30s %s\n" GIT_TAG: "$GIT_TAG"
48 }
49
50 set_variables_common(){
51     echo "INFO: Setting common variables"
52     if [[ -z ${LOGS_SERVER:-} ]] && [[ -z ${CDN_URL:-} ]]; then
53         echo "ERROR: LOGS_SERVER or CDN_URL not defined"
54         exit 1
55     fi
56     NEXUS_PATH="${SILO}/${JENKINS_HOSTNAME}/"
57     # Verify if using release file or parameters
58     if $USE_RELEASE_FILE ; then
59         release_files=$(git diff-tree -m --no-commit-id -r "$GIT_COMMIT" "$GIT_COMMIT^1" \
60             --name-only -- "releases/" ".releases/")
61         if (( $(grep -c . <<<"$release_files") > 1 )); then
62             echo "INFO: RELEASE FILES ARE AS FOLLOWS: $release_files"
63             echo "ERROR: Adding multiple release files in the same commit"
64             echo "ERROR: OR rename/amend/delete of existing files is not supported."
65             exit 1
66         else
67             release_file="$release_files"
68             echo "INFO: RELEASE FILE: $release_files"
69         fi
70     else
71         echo "INFO: This job is built with parameters, no release file needed."
72         release_file="None"
73     fi
74
75     if [[ -z ${LOG_DIR:-} ]]; then
76         LOG_DIR=$(yq -r ".log_dir" "$release_file")
77     fi
78     if [[ -n ${LOGS_SERVER:-} ]]; then
79         logs_url="${LOGS_SERVER}/${NEXUS_PATH}${LOG_DIR}"
80     elif [[ -n ${CDN_URL:-} ]]; then
81         logs_url="https://${CDN_URL:-}/logs/${NEXUS_PATH}${LOG_DIR}"
82     fi
83     logs_url=${logs_url%/}  # strip any trailing '/'
84
85     # Jenkins parameter drop-down defaults DISTRIBUTION_TYPE to None
86     # in the contain/maven release job; get value from release yaml.
87     # Packagecloud and PyPI jobs set the appropriate value.
88     DISTRIBUTION_TYPE="${DISTRIBUTION_TYPE:-None}"
89     if [[ $DISTRIBUTION_TYPE == "None" ]]; then
90         if ! DISTRIBUTION_TYPE=$(yq -r ".distribution_type" "$release_file"); then
91             echo "ERROR: Failed to get distribution_type from $release_file"
92             exit 1
93         fi
94     fi
95
96     PATCH_DIR=$(mktemp -d)
97
98     TAG_RELEASE="${TAG_RELEASE:-None}"
99     if [[ $TAG_RELEASE == "None" ]]; then
100         if grep -q "tag_release" $release_file ; then
101             TAG_RELEASE=$(yq -r .tag_release "$release_file")
102         else
103             TAG_RELEASE=true
104         fi
105     fi
106
107     # Displaying Release Information (Common variables)
108     printf "\t%-30s\n" RELEASE_ENVIRONMENT_INFO:
109     printf "\t%-30s %s\n" RELEASE_FILE: "$release_file"
110     printf "\t%-30s %s\n" LOGS_SERVER: "${LOGS_SERVER:-None}"
111     printf "\t%-30s %s\n" CDN_URL: "${CDN_URL:-None}"
112     printf "\t%-30s %s\n" NEXUS_PATH: "$NEXUS_PATH"
113     printf "\t%-30s %s\n" JENKINS_HOSTNAME: "$JENKINS_HOSTNAME"
114     printf "\t%-30s %s\n" SILO: "$SILO"
115     printf "\t%-30s %s\n" PROJECT: "$PROJECT"
116     printf "\t%-30s %s\n" PROJECT-DASHED: "${PROJECT//\//-}"
117     printf "\t%-30s %s\n" TAG_RELEASE: "$TAG_RELEASE"
118     printf "\t%-30s %s\n" DISTRIBUTION_TYPE: "$DISTRIBUTION_TYPE"
119     printf "\t%-30s %s\n" OVERRIDE_SEMVER_REGEX: "${OVERRIDE_SEMVER_REGEX:-None}"
120 }
121
122 set_variables_container(){
123     echo "INFO: Setting container variables"
124     if [[ -z ${VERSION:-} ]]; then
125         VERSION=$(yq -r ".container_release_tag" "$release_file")
126     fi
127     if [[ -z ${GIT_TAG:-} ]]; then
128         if grep -q "git_tag" "$release_file" ; then
129             GIT_TAG=$(yq -r ".git_tag" "$release_file")
130         else
131             GIT_TAG="$VERSION"
132         fi
133     fi
134     if grep -q "container_pull_registry" "$release_file" ; then
135         CONTAINER_PULL_REGISTRY=$(yq -r ".container_pull_registry" "$release_file")
136     fi
137     if grep -q "container_push_registry" "$release_file" ; then
138         CONTAINER_PUSH_REGISTRY=$(yq -r ".container_push_registry" "$release_file")
139     fi
140     # Make sure both pull and push registries are defined
141     if [ -z ${CONTAINER_PULL_REGISTRY+x} ] || [ -z ${CONTAINER_PUSH_REGISTRY+x} ]; then
142         echo "ERROR: CONTAINER_PULL_REGISTRY and CONTAINER_PUSH_REGISTRY need to be defined"
143         exit 1
144     fi
145     ref=$(yq -r ".ref" "$release_file")
146
147     # Continuing displaying Release Information (Container)
148     printf "\t%-30s\n" RELEASE_CONTAINER_INFO:
149     printf "\t%-30s %s\n" CONTAINER_RELEASE_TAG: "$VERSION"
150     printf "\t%-30s %s\n" CONTAINER_PULL_REGISTRY: "$CONTAINER_PULL_REGISTRY"
151     printf "\t%-30s %s\n" CONTAINER_PUSH_REGISTRY: "$CONTAINER_PUSH_REGISTRY"
152     printf "\t%-30s %s\n" GIT_REF_TO_TAG: "$ref"
153     printf "\t%-30s %s\n" GIT_TAG: "$GIT_TAG"
154 }
155
156 set_variables_maven(){
157     echo "INFO: Setting maven variables"
158     if [[ -z ${VERSION:-} ]]; then
159         VERSION=$(yq -r ".version" "$release_file")
160     fi
161     if [[ -z ${GIT_TAG:-} ]]; then
162         if grep -q "git_tag" "$release_file" ; then
163             GIT_TAG=$(yq -r ".git_tag" "$release_file")
164         else
165             GIT_TAG="$VERSION"
166         fi
167     fi
168     if [[ -z ${LOG_DIR:-} ]]; then
169         LOG_DIR=$(yq -r ".log_dir" "$release_file")
170     fi
171
172     # Continuing displaying Release Information (Maven)
173     printf "\t%-30s\n" RELEASE_MAVEN_INFO:
174     printf "\t%-30s %s\n" VERSION: "$VERSION"
175     printf "\t%-30s %s\n" GIT_TAG: "$GIT_TAG"
176     printf "\t%-30s %s\n" LOG_DIR: "$LOG_DIR"
177     printf "\t%-30s %s\n" LOGS_URL: "$logs_url"
178 }
179
180 set_variables_packagecloud(){
181     echo "INFO: Setting packagecloud variables"
182     if [[ -z ${VERSION:-} ]]; then
183         VERSION=$(yq -r ".version" "$release_file")
184     fi
185     if [[ -z ${GIT_TAG:-} ]]; then
186         if grep -q "git_tag" $release_file ; then
187             GIT_TAG=$(yq -r ".git_tag" "$release_file")
188         else
189             GIT_TAG="$VERSION"
190         fi
191     fi
192     if [[ -z ${LOG_DIR:-} ]]; then
193         LOG_DIR=$(yq -r ".log_dir" "$release_file")
194     fi
195     if [[ -z ${REF:-} ]]; then
196         REF=$(yq -r ".ref" "$release_file")
197     fi
198     if [[ -z ${PACKAGE_NAME:-} ]]; then
199         PACKAGE_NAME=$(yq -r ".package_name" "$release_file")
200     fi
201
202     printf "\t%-30s %s\n" PACKAGE_NAME: "$PACKAGE_NAME"
203     printf "\t%-30s %s\n" LOG_DIR: "$LOG_DIR"
204     printf "\t%-30s %s\n" LOGS_URL: "$logs_url"
205     printf "\t%-30s %s\n" GIT_REF_TO_TAG: "$REF"
206     printf "\t%-30s %s\n" VERSION: "$VERSION"
207     printf "\t%-30s %s\n" GIT_TAG: "$GIT_TAG"
208 }
209
210 set_variables_pypi(){
211     echo "INFO: Setting pypi variables"
212     if [[ -z ${LOG_DIR:-} ]]; then
213         LOG_DIR=$(yq -r ".log_dir" "$release_file")
214     fi
215
216     if [[ -z ${PYPI_PROJECT:-} ]]; then
217         PYPI_PROJECT=$(yq -r ".pypi_project" "$release_file")
218     fi
219     if [[ -z ${PYTHON_VERSION:-} ]]; then
220         PYTHON_VERSION=$(yq -r ".python_version" "$release_file")
221     fi
222     if [[ -z ${VERSION:-} ]]; then
223         VERSION=$(yq -r ".version" "$release_file")
224     fi
225     if [[ -z ${GIT_TAG:-} ]]; then
226         if grep -q "git_tag" "$release_file" ; then
227             GIT_TAG=$(yq -r ".git_tag" "$release_file")
228         else
229             GIT_TAG="$VERSION"
230         fi
231     fi
232
233     # Continuing displaying Release Information (pypi)
234     printf "\t%-30s\n" RELEASE_PYPI_INFO:
235     printf "\t%-30s %s\n" LOG_DIR: "$LOG_DIR"
236     printf "\t%-30s %s\n" LOGS_URL: "$logs_url"
237     printf "\t%-30s %s\n" PYPI_INDEX: "$PYPI_INDEX" # from job configuration
238     printf "\t%-30s %s\n" PYPI_PROJECT: "$PYPI_PROJECT"
239     printf "\t%-30s %s\n" PYTHON_VERSION: "$PYTHON_VERSION"
240     printf "\t%-30s %s\n" VERSION: "$VERSION"
241     printf "\t%-30s %s\n" GIT_TAG: "$GIT_TAG"
242 }
243
244 ##########################
245 # Verify Schema Functions.
246 ##########################
247
248 verify_packagecloud_match_release(){
249     echo "INFO: Fetching console log from $logs_url"
250     wget -q -P /tmp "${logs_url}/"console.log.gz
251     echo "INFO: Searching for uploaded step, package name $PACKAGE_NAME and version $VERSION in job log"
252     if  zgrep -E "Pushing.*$PACKAGE_NAME.*$VERSION.*success\!" /tmp/console.log.gz; then
253         echo "INFO: found expected strings in job log"
254     else
255         echo "ERROR: failed to find expected strings in job log"
256         exit 1
257     fi
258 }
259
260 verify_pypi_match_release(){
261     echo "INFO: Fetching console log from $logs_url"
262     wget -q -P /tmp "${logs_url}/"console.log.gz
263     echo "INFO: Searching for uploaded step, project $PYPI_PROJECT and version $VERSION in job log"
264     # pypi-upload.sh generates success message with file list
265     if zgrep -i "uploaded" /tmp/console.log.gz | grep "$PYPI_PROJECT" | grep "$VERSION" ; then
266         echo "INFO: found expected strings in job log"
267     else
268         echo "ERROR: failed to find expected strings in job log"
269         exit 1
270     fi
271 }
272
273 verify_schema(){
274     echo "INFO: Verifying $release_file against schema $release_schema"
275     lftools schema verify "$release_file" "$release_schema"
276 }
277
278 verify_version(){
279     # Override the regex for projects that do not follow https://semver.org
280     OVERRIDE_SEMVER_REGEX="${OVERRIDE_SEMVER_REGEX:-None}"
281     if [[ $OVERRIDE_SEMVER_REGEX == "None" ]]; then
282         # Use the semver regex taken from https://github.com/fsaintjacques/semver-tool
283         semver_regex="^[vV]?(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)(\-(0|[1-9][0-9]*|[0-9]*[A-Za-z-][0-9A-Za-z-]*)(\.(0|[1-9][0-9]*|[0-9]*[A-Za-z-][0-9A-Za-z-]*))*)?(\+[0-9A-Za-z-]+(\.[0-9A-Za-z-]+)*)?$"
284     else
285         semver_regex="${OVERRIDE_SEMVER_REGEX}"
286     fi
287
288     # Verify SemVer "#.#.#" (SemVer) or "v#.#.#"
289     echo "INFO: Verifying version $VERSION"
290     if [[ $VERSION =~ $semver_regex ]]; then
291         echo "INFO: The version $VERSION is valid"
292     else
293         echo "ERROR: The version $VERSION is not valid"
294         echo "ERROR: Valid versions are \"#.#.#\" (SemVer) or \"v#.#.#\""
295         echo "ERROR: Valid version will be matched against \"${semver_regex}\""
296         echo "ERROR: Refer to https://semver.org/ for more details on SemVer"
297         echo "ERROR: Refer SemVer examples from https://github.com/fsaintjacques/semver-tool/#examples"
298         exit 1
299     fi
300 }
301
302 verify_version_match_release(){
303     echo "INFO: Fetching console log from $logs_url"
304     wget -P /tmp "${logs_url}/"console.log.gz
305     echo "INFO: Searching for uploaded step and version $VERSION in job log"
306     if zgrep "Successfully uploaded" /tmp/console.log.gz | grep "$VERSION"; then
307         echo "INFO: found expected strings in job log"
308     else
309         echo "ERROR: Defined version in release file does not match staging repo artifacts version to be released"
310         echo "ERROR: Please make sure maven stage job log dir and release version are both correct"
311         exit 1
312     fi
313 }
314
315
316 #####################
317 # Tag Repo Functions.
318 #####################
319
320 # sigul is only available on Centos
321 # TODO: write tag-github-repo function
322 tag-git-repo(){
323     if [[ $TAG_RELEASE == false ]]; then
324         echo "INFO: Skipping code repo tag"
325         return
326     fi
327
328     if [[ -z ${GERRIT_URL:-} ]]; then
329         GIT_REPO_BASE=github
330     else
331         GIT_REPO_BASE=gerrit
332     fi
333
334     echo "INFO: tag repo with $GIT_TAG"
335     # Import public signing key
336     gpg --import "$SIGNING_PUBKEY"
337     if type=$(git cat-file -t "$GIT_TAG"); then
338         if [[ $type == "tag" ]]; then
339             echo "INFO: Repo already has signed tag $GIT_TAG, nothing to do"
340         else
341             echo "ERROR: Repo has lightweight tag $GIT_TAG, blocks push of signed tag"
342             exit 1
343         fi
344     else
345         echo "INFO: Repo has not yet been tagged $GIT_TAG"
346         git tag -am "${PROJECT//\//-} $GIT_TAG" "$GIT_TAG"
347         sigul --batch -c "$SIGUL_CONFIG" sign-git-tag "$SIGUL_KEY" "$GIT_TAG" < "$SIGUL_PASSWORD"
348         echo "INFO: Showing latest signature for $PROJECT:"
349         echo "INFO: git tag -v $GIT_TAG"
350         git tag -v "$GIT_TAG"
351
352         ########## Merge Part ##############
353         if [[ "$JOB_NAME" =~ "merge" ]] && [[ "$DRY_RUN" = false ]]; then
354             echo "INFO: Running merge, pushing tag"
355             if [[ $GIT_REPO_BASE == "gerrit" ]]; then
356                 gerrit_ssh=$(echo "$GERRIT_URL" | awk -F"/" '{print $3}')
357                 git remote set-url origin ssh://"$RELEASE_USERNAME"@"$gerrit_ssh":29418/"$PROJECT"
358                 echo -e "Host $gerrit_ssh\n\tStrictHostKeyChecking no\n" >> ~/.ssh/config
359                 chmod 600 ~/.ssh/config
360             else
361                 git remote set-url origin "$GIT_CLONE_URL""$RELEASE_USERNAME"/"$PROJECT".git
362             fi
363             git config user.name "$RELEASE_USERNAME"
364             git config user.email "$RELEASE_EMAIL"
365             git push origin "$GIT_TAG"
366         fi
367     fi
368 }
369
370 ###############################
371 # Release Processing Functions.
372 ###############################
373
374 artifact_release_file(){
375     echo "INFO: Processing artifact release"
376     mkdir artifacts
377     ORG=$(echo "$NEXUS_URL" | awk -F'.' '{print $2}')
378
379     for namequoted in $(yq '.artifacts[].name' $release_file); do
380         pathquoted=$(yq ".artifacts[] |select(.name==$namequoted) |.path" $release_file)
381
382         #Remove extra yaml quotes
383         name="${namequoted#\"}"
384         name="${name%\"}"
385         path="${pathquoted#\"}"
386         path="${path%\"}"
387
388         echo "$name"
389         echo "$path"
390         echo "INFO: Merge will post artifact: $name"
391         # Attempt to pull from releases to see if the artifact has been released.
392         if "${NEXUS_URL}"/content/repositories/releases/org/"${ORG}"/"${VERSION}"/"$name"; then
393             echo "INFO: $name is already released as version:$VERSION, Continuing..."
394         else
395             echo "INFO: $name not found in releases, release will be prepared. Continuing..."
396             wget "${path}"/"${name}" -o artifacts/"${name}"
397             if [[ "$JOB_NAME" =~ "merge" ]] && [[ "$DRY_RUN" = false ]]; then
398                 #lftools sign sigul artifacts
399                 curl -v -u <NEXUSUSER>:<NEXUSPASS> --upload-file "${NEXUS_URL}"/content/repositories/releases/org/"${ORG}"/"${VERSION}"/"${name}" \;
400             fi
401             echo "#########################"
402         fi
403     done
404 }
405
406 container_release_file(){
407     echo "INFO: Processing container release"
408     docker --version
409     local lfn_umbrella
410     lfn_umbrella="$(echo "$GERRIT_URL" | awk -F"." '{print $2}')"
411
412     for namequoted in $(yq '.containers[].name' $release_file); do
413         versionquoted=$(yq ".containers[] |select(.name==$namequoted) |.version" $release_file)
414
415         #Remove extra yaml quotes
416         name="${namequoted#\"}"
417         name="${name%\"}"
418         version="${versionquoted#\"}"
419         version="${version%\"}"
420
421         echo "$name"
422         echo "$version"
423         echo "INFO: Merge will release $name $version as $VERSION"
424         # Attempt to pull from releases registry to see if the image has been released.
425         if docker pull "$CONTAINER_PUSH_REGISTRY"/"$lfn_umbrella"/"$name":"$VERSION"; then
426             echo "INFO: $VERSION is already released for image $name, Continuing..."
427         else
428             echo "INFO: $VERSION not found in releases, release will be prepared. Continuing..."
429             docker pull "$CONTAINER_PULL_REGISTRY"/"$lfn_umbrella"/"$name":"$version"
430             container_image_id=$(docker images | grep "$name" | grep "$version" | awk '{print $3}')
431             echo "INFO: Merge will run the following commands:"
432             echo "docker tag $container_image_id $CONTAINER_PUSH_REGISTRY/$lfn_umbrella/$name:$VERSION"
433             echo "docker push $CONTAINER_PUSH_REGISTRY/$lfn_umbrella/$name:$VERSION"
434             if [[ "$JOB_NAME" =~ "merge" ]]; then
435                 docker tag "$container_image_id" "$CONTAINER_PUSH_REGISTRY"/"$lfn_umbrella"/"$name":"$VERSION"
436                 docker push "$CONTAINER_PUSH_REGISTRY"/"$lfn_umbrella"/"$name":"$VERSION"
437             fi
438             echo "#########################"
439         fi
440     done
441
442     echo "INFO: Merge will tag ref: $ref"
443     git checkout "$ref"
444     tag-git-repo
445 }
446
447 maven_release_file(){
448     echo "INFO: Processing maven release"
449     echo "INFO: wget -P $PATCH_DIR ${logs_url}/staging-repo.txt.gz"
450     wget -P "$PATCH_DIR" "${logs_url}/"staging-repo.txt.gz
451     pushd "$PATCH_DIR"
452         echo "INFO: wget ${logs_url}/patches/{${PROJECT//\//-}.bundle,taglist.log.gz}"
453         wget "${logs_url}"/patches/{"${PROJECT//\//-}".bundle,taglist.log.gz}
454         gunzip taglist.log.gz
455         cat "$PATCH_DIR"/taglist.log
456     popd
457     git checkout "$(awk '{print $NF}' "$PATCH_DIR/taglist.log")"
458     git fetch "$PATCH_DIR/${PROJECT//\//-}.bundle"
459     git merge --ff-only FETCH_HEAD
460     nexus_release
461     tag-git-repo
462 }
463
464 nexus_release(){
465     echo "INFO: Processing nexus release"
466     for staging_url in $(zcat "$PATCH_DIR"/staging-repo.txt.gz | awk -e '{print $2}'); do
467         # extract the domain name from URL
468         NEXUS_URL=$(echo "$staging_url" | sed -e 's|^[^/]*//||' -e 's|/.*$||')
469         echo "INFO: NEXUS_URL: $NEXUS_URL"
470         # extract the staging repo from URL
471         STAGING_REPO=${staging_url#*repositories/}
472         echo "INFO: Running Nexus Verify"
473         lftools nexus release -v --server https://"$NEXUS_URL" "$STAGING_REPO"
474         echo "INFO: Merge will run:"
475         echo "lftools nexus release --server https://$NEXUS_URL $STAGING_REPO"
476     done
477
478     #Run the loop twice, to catch errors on either nexus repo
479     if [[ "$JOB_NAME" =~ "merge" ]] && [[ "$DRY_RUN" = false ]]; then
480         for staging_url in $(zcat "$PATCH_DIR"/staging-repo.txt.gz | awk -e '{print $2}'); do
481             NEXUS_URL=$(echo "$staging_url" | sed -e 's|^[^/]*//||' -e 's|/.*$||')
482             STAGING_REPO=${staging_url#*repositories/}
483             echo "INFO: Promoting $STAGING_REPO on $NEXUS_URL."
484             lftools nexus release --server https://"$NEXUS_URL" "$STAGING_REPO"
485         done
486     fi
487 }
488
489 packagecloud_promote(){
490     echo "INFO: Preparing to promote $1..."
491     promote_url="https://packagecloud.io$(curl --netrc-file ~/packagecloud_api \
492         --silent https://packagecloud.io/api/v1/repos/"$2"/staging/search?q="$1" \
493         | yq -r .[].promote_url)"
494     echo "INFO: Promoting $1 from staging to release"
495     curl --netrc-file ~/packagecloud_api -X POST -F \
496         destination="$2/release" "$promote_url" \
497         | echo "INFO: Promoted package location: \
498         https://packagecloud.io$(yq -r .package_html_url)"
499     git checkout "$REF"
500     tag-git-repo
501 }
502
503 packagecloud_verify(){
504     echo "INFO: Verifying $1 exists in staging..."
505     if [[ $1 == $(curl --netrc-file ~/packagecloud_api --silent \
506         https://packagecloud.io/api/v1/repos/"$2"/staging/search?q="$1" \
507         | yq -r .[].filename) ]]; then
508         echo "INFO: $1 exists in staging!"
509         echo "INFO: Existing package location: https://packagecloud.io$(curl \
510             --netrc-file ~/packagecloud_api --silent \
511             https://packagecloud.io/api/v1/repos/"$2"/staging/search?q="$1" \
512             | yq -r .[].package_html_url)"
513     else
514         echo "ERROR: $1 does not exist in staging"
515         exit 1
516     fi
517 }
518
519 # calls pip to download binary and source distributions from the specified index,
520 # which requires a recent-in-2019 version.  Uploads the files it received.
521 pypi_release_file(){
522     echo "INFO: Processing pypi release"
523     tgtdir=dist
524     mkdir $tgtdir
525     pip_pfx="pip download -d $tgtdir --no-deps --python-version $PYTHON_VERSION -i $PYPI_INDEX"
526     module="$PYPI_PROJECT==$VERSION"
527     pip_bin="$pip_pfx $module"
528     echo "INFO: downloading binary: $pip_bin"
529     if ! $pip_bin ; then
530         echo "WARN: failed to download binary distribution"
531     fi
532     pip_src="$pip_pfx --no-binary=:all: $module"
533     echo "INFO: downloading source: $pip_src"
534     if ! $pip_src ; then
535         echo "WARN: failed to download source distribution"
536     fi
537     echo "INFO: Checking files in $tgtdir"
538     # shellcheck disable=SC2012
539     filecount=$(ls $tgtdir | wc -l)
540     if [[ $filecount = 0 ]] ; then
541         echo "ERROR: no files downloaded"
542         exit 1
543     else
544         # shellcheck disable=SC2046
545         echo "INFO: downloaded $filecount distributions: " $(ls $tgtdir)
546     fi
547
548     if [[ ! "$JOB_NAME" =~ "merge" ]] ; then
549         echo "INFO: not a merge job, not uploading files"
550         return
551     fi
552
553     cmd="twine upload -r $REPOSITORY $tgtdir/*"
554     if $DRY_RUN; then
555         echo "INFO: dry-run is set, echoing command only"
556         echo "$cmd"
557     else
558         echo "INFO: uploading $filecount distributions to repo $REPOSITORY"
559         $cmd
560     fi
561     tag-git-repo
562 }
563
564 ##############################  End Function Declarations  ################################
565
566 # Set common environment variables
567 set_variables_common
568
569 # Determine the type of release:
570 #   - artifact, release-artifact-schema.yaml
571 #   - container, release-container-schema.yaml
572 #   - maven, release-schema.yaml
573 #   - packagecloud, release-packagecloud-schema.yaml
574 #   - pypi,  release-pypi-schema.yaml
575
576 case $DISTRIBUTION_TYPE in
577
578     artifact)
579         if $USE_RELEASE_FILE ; then
580             release_schema="release-artifact-schema.yaml"
581             echo "INFO: Fetching schema $release_schema"
582             wget -q https://raw.githubusercontent.com/lfit/releng-global-jjb/master/schema/${release_schema}
583             verify_schema
584         fi
585         set_variables_artifact
586         verify_version
587         artifact_release_file
588         ;;
589
590     container)
591         if $USE_RELEASE_FILE ; then
592             release_schema="release-container-schema.yaml"
593             echo "INFO: Fetching schema $release_schema"
594             wget -q https://raw.githubusercontent.com/lfit/releng-global-jjb/master/schema/${release_schema}
595             verify_schema
596         fi
597         set_variables_container
598         verify_version
599         container_release_file
600         ;;
601
602     maven)
603         if $USE_RELEASE_FILE ; then
604             release_schema="release-schema.yaml"
605             echo "INFO: Fetching schema $release_schema"
606             wget -q https://raw.githubusercontent.com/lfit/releng-global-jjb/master/schema/$release_schema
607             verify_schema
608         fi
609         set_variables_maven
610         verify_version
611         verify_version_match_release
612         maven_release_file
613         ;;
614
615     packagecloud)
616         if $USE_RELEASE_FILE ; then
617             release_schema="release-packagecloud-schema.yaml"
618             packagecloud_account=$(cat "$ACCOUNT_NAME_FILE")
619             echo "INFO: Fetching schema $release_schema"
620             wget -q https://raw.githubusercontent.com/lfit/releng-global-jjb/master/schema/${release_schema}
621             verify_schema
622         fi
623         set_variables_packagecloud
624         verify_packagecloud_match_release
625         for name in $(yq -r '.packages[].name' $release_file); do
626             package=$name
627             packagecloud_verify "$package" "$packagecloud_account"
628             if [[ "$JOB_NAME" =~ "merge" ]] && ! $DRY_RUN; then
629                 packagecloud_promote "$package" "$packagecloud_account"
630             fi
631         done
632         ;;
633
634     pypi)
635         if $USE_RELEASE_FILE ; then
636             release_schema="release-pypi-schema.yaml"
637             echo "INFO: Fetching schema $release_schema"
638             wget -q https://raw.githubusercontent.com/lfit/releng-global-jjb/master/schema/${release_schema}
639             verify_schema
640         fi
641         set_variables_pypi
642         verify_version
643         verify_pypi_match_release
644         pypi_release_file
645         ;;
646
647     *)
648         echo "ERROR: distribution_type: $DISTRIBUTION_TYPE not supported"
649         exit 1
650         ;;
651 esac
652
653 echo "---> release-job.sh ends"